source("aici.R")

mdpe2in <- function() {
  if (what) {
    if (tnrm) {
      z <- rep(rlnorm(n,0,w),each=m)*(1+rtruncnorm(n*m,-1,1,0,s))
    } else {
      z <- rep(rlnorm(n,0,w),each=m)*(1+rnorm(n*m,0,s))
    }
  } else {
    if (tnrm) {
      z <- rep(rlnorm(n,0,w),each=m)+rtruncnorm(n*m,-1,1,0,s)
    } else {
      z <- rep(rlnorm(n,0,w),each=m)+rnorm(n*m,0,s)
    }
  }
  mean((z-1)^2)
}

mdpe2i <- function() {
  z <- rep(rlnorm(n,0,w),each=m)+rnorm(n*m,0,s)
  mean((z-1)^2)
}

mdpe2 <- function(n) {
  if (nonmem) {
    mean(unlist(mclapply(1:n, function(i) mdpe2in())))
  } else {
    mean(unlist(mclapply(1:n, function(i) mdpe2i())))
  }
}

aic0 <- log(s2) + log(2*pi) + 1

if (w2>0) {
  mpe20 <- mdpe2(100000)
} else {
  mpe20 <- s2
}

aicv0 <- aic0

if (nonmem) {

# create data structures and include file

nd <- NULL
nd$ID <- rep(1:n,each=m)
nd$TIME <- rep(t,n)
nd$WT <- ynp
nd$DV <- rep(0,mn)

input <- "$INPUT ID TIME WT DV"
for (i in 1:m) {
  ndei <- rep(exp(-lambda[i]*t),n)
  nd[[paste("E",i,sep="")]] <- ndei
  input <- paste(input," E",i,sep="")
}

ndv <- nd

cat(paste(input,"\n",sep=""),file="aicinput.inc")

}

# create model set
source("aicbs.R")

# define fitting functions
source("aicf.R")

# the works
if (nonmem) {
  ar <- lapply(1:ns, runmnm, d, bs)
} else {
  ar <- mclapply(1:ns, runm, d, bs)
}

rar <- ar

for (is in 1:ns) {
  for (i in minms:maxms1) {
    rar[[is]][[i]][[2]] <- ar[[is]][[i]][[2]]-ar[[is]][[i+1]][[2]]
    rar[[is]][[i]][[3]] <- ar[[is]][[i]][[3]]-ar[[is]][[maxms]][[3]]
    rar[[is]][[i]][[4]] <- ar[[is]][[i]][[4]]-ar[[is]][[maxms]][[4]]
    rar[[is]][[i]][[5]] <- ar[[is]][[i]][[5]]-ar[[is]][[maxms]][[5]]
  }
}

uar <- unlist(ar)
urar <- unlist(rar)

idx <- (0:(ns-1))*maxms*nr

nmerrs <- function() {
  for (i in 1:maxms) {
    z <- uar[idx+(i-1)*nr+1]
    n <- length(which(z!=0))
    print(paste(i,n))
  }
}

if (nonmem) {
  nmerrs()
}

if (makepdf || makeeps) {
  source("aicp.R")
}

save.image()
