# initialize

source("aicai.R")
source("aicf.R")

# run all possible combinations for a data set,
# except none or all lambdas

runi <- function(i,d)
{
#  print(i)
  b <- intToBits(i)[1:m]
  fm <- fitmodel(b,d)
  afm <- AICs(fm,d)
  c(0,afm[1],afm[2],afm[3],afm[5],length(fm$coefficients))
}

nr <- 6 # considering runi

if (n>1) {
  nm <- 2^m-1
} else {
  nm <- 2^m-2
}

for (i in 1:ns) {

print(i)

d$DV  <- ynp*(rep(rlnorm(n,0,w),each=m)+rnorm(n*m,0,s))
d$DVV <- ynp*(rep(rlnorm(n,0,w),each=m)+rnorm(n*m,0,s))

ar <- mclapply(1:nm, runi, d)

if (i==1) {
  uar <- unlist(ar)
} else {
  uar <- uar + unlist(ar)
}
  
}

uar <- uar/ns

i <- 0:(nm-1)

m2ll <- uar[i*nr+2]
aic <- uar[i*nr+3]
aicc <- uar[i*nr+4]
mpe2 <- uar[i*nr+5]
ms <- uar[i*nr+6]

source("aicbs.R")

b2i <- function(b) {
  ib <- 0
  ip <- 1
  for (i in m:1) {
    ib <- ib + as.integer(b[i])*ip
    ip <- ip*2
  }
  ib
}

setEPS()
postscript(file="fig.eps",paper="special",width=6,height=6)

idx <- rep(T,nm)
for (i in 1:m) {
  idx[b2i(bs[[i]])] <- F
}

plot(ms[idx],mpe2[idx],xlim=c(0,12),ylim=c(0.5,1.5),xlab="Number of exponentials",ylab="Mean squared prediction error",cex=0.5)
idx <- !idx
points(ms[idx],mpe2[idx],pch=19,cex=1.25)
lines(c(0,12),c(s2,s2),lty="dashed")
grid()

dev.off()
