library(parallel)
library(car)
library(gplots)
library(truncnorm)
library(XML) # to read NONMEM's output file
library(descr)

# for runnm
wd <- getwd()

ns <- 1000 # simulations

source("aico.R")

if (ns==1) makepdf <- F

mn <- m*n
s <- sqrt(s2)
w <- sqrt(w2)
gam <- log(tmax)/log(m)

# minimal model size (for plots only)

if (w2>0) {
  minms <- 4
} else {
  minms <- 1
}

# maximum model size

if (n>1) {
  maxms <- m
} else {
  maxms <- m-1
}

#possibly override
#minms <- 7
#maxms <- 5

maxms1 <- maxms-1

j <- 1:m
t <- (j/(m+1-j))^gam

yn <- 1/t
ynp <- rep(yn,n)

lambda <- 1/t

d <- data.frame(WT=ynp)
for (i in 1:m) {
  d[[paste("E",i,sep="")]] <- rep(exp(-lambda[i]*t),n)
}

# define global ypr needed for the `whats' option; accessed in runnm and runmnm

ypr <- rep(0,mn)
