jm <- minms:maxms
jm1 <- minms:maxms1

minmaxi <- function(uar,i,ip) {
  minz <- -1
  maxz <- -1
  z <- uar[idx+(i-1)*nr+ip]
  zok <- which(uar[idx+(i-1)*nr+1]==0)
  if (length(zok)>0) {
    z <- z[zok]
    zok <- which(z<Inf)
    if (length(zok)>0) {
      z <- z[zok]
      mnz <- mean(z)
      ciz <- 2*sd(z)/sqrt(length(z))
      minz <- mnz-ciz
      maxz <- mnz+ciz
    }
  }
  c(minz,maxz)
}

minmax <- function(uar,ip,maxms) {
  mm <- minmaxi(uar,minms,ip)
  for (i in (minms+1):maxms) {
    mmi <- minmaxi(uar,i,ip)
    if (!(is.na(mmi[1]))) { if (mmi[1]<mm[1]) mm[1] <- mmi[1] }
    if (!(is.na(mmi[2]))) { if (mmi[2]>mm[2]) mm[2] <- mmi[2] }
  }
  mm
}

aiccna <- function() {
  mmxc <- maxms
  for (i in minms:maxms)
  if (is.na(uar[idx+(i-1)*nr+4][1])) return(i-1)
}

m2llmm <- minmax(uar,2,maxms)
aicmm <- minmax(uar,3,maxms)
aiccmm <- minmax(uar,4,maxms)
aicvmm <- minmax(uar,5,maxms)
mpe2mm <- minmax(uar,6,maxms)
s2mm <- minmax(uar,7,maxms)
w2mm <- minmax(uar,8,maxms)

rm2llmm <- minmax(urar,2,maxms1)
raicmm <- minmax(urar,3,maxms1)
raiccmm <- minmax(urar,4,maxms1)
raicvmm <- minmax(urar,5,maxms1)

sfm <- function(i,uar,ip) {
  z <- uar[idx+(i-1)*nr+ip]
  zok <- which(uar[idx+(i-1)*nr+1]==0)
  z <- z[zok]
  zok <- which(z<Inf)
  z <- z[zok]
  fm <-lm(z~1)
}

sfm2 <- function(i,uar,ip1,ip2) {
  z1 <- uar[idx+(i-1)*nr+ip1]
  z2 <- uar[idx+(i-1)*nr+ip2]
  zok <- which(uar[idx+(i-1)*nr+1]==0)
  z1 <- z1[zok]
  z2 <- z2[zok]
  fm <-lm(cbind(z1,z2)~1)
}

maicc <- function(i)
{
  iere <- uar[idx[i]+((minms:maxms)-1)*nr+1]
  if (length(which(iere!=0))>0) {
    m <- NA
  } else {
    m <- minms-1+order(uar[idx[i]+((minms:maxms)-1)*nr+4])[1]
  }
  m
}

if (makepdf) {
  pdf(file="sim.pdf", paper="A4", width=8, height=11, useDingbats=F)
}

if (makeeps) {
  setEPS(height=8)
  postscript(file="fig.eps",paper="A4")
  par(mfrow = c(4,2), pty="m", oma=c(0,0,1.5,0), mar=c(4,4,3,2))
} else {
  par(mfrow = c(3,2), pty="m", oma=c(0,0,1.5,0), mar=c(4,4,3,2))
}

cc <- 1
if (n>1) {
  maxmsc <- maxms
} else {
  maxmsc <- aiccna()
}

if (!imponly) {

print("plot 1")
fms <- lapply(minms:maxms, sfm2, uar, 2, 5)
confidenceEllipse(fms[[1]],col="black",xlab="-2LL",ylab="OFVv",xlim=c(m2llmm[1],m2llmm[2]),ylim=c(min(aicvmm[1],aic0),aicvmm[2]),lwd=1,center.cex=cc,center.pch=19)
for (i in (minms+1):maxms) {
confidenceEllipse(fms[[i-minms+1]],col="black",add=T,lwd=1,center.cex=cc,center.pch=19)
}
lines(c(m2llmm[1],m2llmm[2]),c(aic0,aic0),lty="dashed")

}

print("plot 2")
fms <- lapply(minms:maxms, sfm, uar, 5)
ys <- as.double(sapply(minms:maxms, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[2]]))
#plotCI(x=jm,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="OFVv",ylim=c(min(aic0,aicvmm[1]),aicvmm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
plotCI(x=jm,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="OFVv",ylim=c(aicvmm[1],aicvmm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
#lines(c(minms,maxms),c(aic0,aic0),lty="dashed")

if (!imponly) {

print("plot 3")
fms <- lapply(minms:maxms, sfm2, uar, 3, 5)
confidenceEllipse(fms[[1]],col="black",xlab="AIC",ylab="OFVv",xlim=c(aicmm[1],aicmm[2]),ylim=c(aicvmm[1],aicvmm[2]),lwd=1,center.cex=cc,center.pch=19)
for (i in (minms+1):maxms) {
confidenceEllipse(fms[[i-minms+1]],col="black",add=T,lwd=1,center.cex=cc,center.pch=19)
}
#lines(c(aicmm[1],aicmm[2]),c(aic0,aic0),lty="dashed")
lines(c(aicmm[1],aicmm[2]),c(aicmm[1],aicmm[2]),lty="solid")

print("plot 4")
fms <- lapply(minms:maxmsc, sfm2, uar, 4, 5)
confidenceEllipse(fms[[1]],col="black",xlab="AICc",ylab="OFVv",xlim=c(aiccmm[1],aiccmm[2]),ylim=c(aicvmm[1],aicvmm[2]),lwd=1,center.cex=cc,center.pch=19)
for (i in (minms+1):maxmsc) {
confidenceEllipse(fms[[i-minms+1]],col="black",add=T,lwd=1,center.cex=cc,center.pch=19)
}
#lines(c(aiccmm[1],aiccmm[2]),c(aic0,aic0),lty="dashed")
lines(c(aiccmm[1],aiccmm[2]),c(aiccmm[1],aiccmm[2]),lty="solid")

print("plot 5")
fms <- lapply(minms:maxms, sfm, uar, 3)
ys <- as.double(sapply(minms:maxms, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[2]]))
plotCI(x=jm,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="AIC",ylim=c(min(aicmm[1],aic0),aicmm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
lines(c(minms,maxms),c(aic0,aic0),lty="dashed")

}

print("plot 6")
fms <- lapply(minms:maxmsc, sfm, uar, 4)
ys <- as.double(sapply(minms:maxmsc, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxmsc, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxmsc, function(i) confint(fms[[i-minms+1]])[[2]]))
#plotCI(x=minms:maxmsc,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="AICc",ylim=c(min(aic0,aiccmm[1]),aiccmm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
plotCI(x=minms:maxmsc,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="AICc",ylim=c(aiccmm[1],aiccmm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
#lines(c(minms,maxms),c(aic0,aic0),lty="dashed")


if (makepdf) {

mtext(paste("NS=",ns,"; N=",n,"; M=",m,"; W^2=",w2,"; S^2=",s2,"; NONMEM=",nonmem,sep=""),outer=T)


print("plot 7")
fms <- lapply(minms:maxms, sfm, uar, 7)
ys <- as.double(sapply(minms:maxms, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[2]]))
plotCI(x=minms:maxms,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="S2",ylim=c(s2mm[1],max(s2,s2mm[2])),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
lines(c(minms,maxms),c(s2,s2),lty="dashed")

if (w2>0 && !naive && nonmem==T) {

print("plot 8")
fms <- lapply(minms:maxms, sfm, uar, 8)
ys <- as.double(sapply(minms:maxms, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[2]]))
plotCI(x=minms:maxms,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="W2",ylim=c(w2mm[1],max(w2,w2mm[2])),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
lines(c(minms,maxms),c(w2,w2),lty="dashed")

}

print("plot 9")
fms <- lapply(minms:maxms1, sfm, urar, 5)
ys <- as.double(sapply(minms:maxms1, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[2]]))
plotCI(x=jm1,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="delta OFVv",ylim=c(min(raicvmm[1],0),max(raicvmm[2],0)),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
lines(c(minms,maxms1),c(0,0),lty="dashed")

print("plot 10")
fms <- lapply(minms:maxms1, sfm, urar, 3)
ys <- as.double(sapply(minms:maxms1, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[2]]))
plotCI(x=jm1,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="delta AIC",ylim=c(min(raicmm[1],0),max(raicmm[2],0)),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
lines(c(minms,maxms1),c(0,0),lty="dashed")

if (n>1) {

print("plot 11")
fms <- lapply(minms:maxms1, sfm, urar, 4)
ys <- as.double(sapply(minms:maxms1, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[2]]))
plotCI(x=jm1,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="delta AICc",ylim=c(min(raiccmm[1],0),max(raiccmm[2],0)),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
lines(c(minms,maxms1),c(0,0),lty="dashed")

}

} # makepdf (possibly uncomment, see below)

print("plot 12")
fms <- lapply(minms:maxms, sfm, uar, 6)
ys <- as.double(sapply(minms:maxms, function(i) coef(fms[[i-minms+1]])))
yls <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[1]]))
yus <- as.double(sapply(minms:maxms, function(i) confint(fms[[i-minms+1]])[[2]]))
#plotCI(x=jm,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="Mean squared prediction error",ylim=c(min(mpe20,mpe2mm[1]),mpe2mm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
plotCI(x=jm,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab="Mean squared prediction error",ylim=c(mpe2mm[1],mpe2mm[2]),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))
#lines(c(minms,maxms),c(mpe20,mpe20),lty="dashed")

print("plot 13")
maiccs <- sapply(1:ns, maicc)
maiccs <- maiccs[!is.na(maiccs)]
f <- freq(maiccs,plot=F)
fx <- as.integer(attributes(attributes(f)$xdata.p)$dimnames[[1]])
ys <- attributes(f)$xdata.p/100
yss <- 1.96*sqrt(ys*(1-ys)/length(maiccs))

# for a consistent figure 4
# fx <- c(fx,11)
# ys <- c(ys,0)
# yss <- c(yss,0)

plotCI(x=fx,y=ys,li=ys-yss,ui=ys+yss,xlab="Number of exponentials",ylab="Selection frequency (%)",xlim=c(minms-1,maxms+1),lwd=1,gap=0,pch=19,panel.first=grid(lty="solid"))

# look at forward selection
#fms <- lapply(minms:maxms1, sfm, urar, 2)
#ys <- as.double(sapply(minms:maxms1, function(i) coef(fms[[i-minms+1]])))
#yls <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[1]]))
#yus <- as.double(sapply(minms:maxms1, function(i) confint(fms[[i-minms+1]])[[2]]))
#plotCI(x=jm1,y=ys,li=yls,ui=yus,xlab="Number of exponentials",xlim=c(minms-1,maxms+1),ylab#="delta -2LL",ylim=c(rm2llmm[1],max(rm2llmm[2],6.63/mn)),lwd=1,gap=0,pch=19,panel.first=gr#id(lty="solid"))
#lines(c(minms,maxms1),c(2/mn,2/mn),lty="dashed")
#lines(c(minms,maxms1),c(6.63/mn,6.63/mn),lty="dotted")

#} # makepdf

dev.off()
